//---------------------------------------------------------------------------
// ϧ½ d1
// 2003-Oct-11 by Royce Wu
//---------------------------------------------------------------------------

#include <vcl.h>
#include <Jpeg.hpp>

#include <algorithm>
#include <cassert>
#pragma hdrstop

#include "U_ImgRot01.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

char* g_vPixelFormatStr[] = {
   "Device",
   "1 bit",
   "4 bits",
   "8 bits",
   "15 bits",
   "16 bits",
   "24 bits",
   "32 bits"
};
short g_vPixelFormatSize[] = {
   24,
   1,
   4,
   8,
   15,
   16,
   24,
   32
};

typedef byte (*my4BAry)[4];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::ImgFit2Rect(TImage* pImg, TRect& rRct)
{
   Graphics::TBitmap* pBmp = pImg->Picture->Bitmap;

   float fScaleFactor1 = 1.0;
   float fScaleFactor2 = 1.0;
   
   if (pBmp->Width > rRct.Width())
      fScaleFactor1 = float(pBmp->Width) / float(rRct.Width());

   if (pBmp->Height > rRct.Height())
      fScaleFactor2 = float(pBmp->Height) / float(rRct.Height());

   float fShrinkFactor = std::max(fScaleFactor1, fScaleFactor2);
   pImg->Width = 0.5 + float(pBmp->Width) / float(fShrinkFactor);
   pImg->Height = 0.5 + float(pBmp->Height) / float(fShrinkFactor);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   OpenDialog1->Filter = "JPG image|*.jpg|BMP image|*.bmp";
   OpenDialog1->DefaultExt = "*.jpg";
   OpenDialog1->FileName = "";

   OpenDialog1->Execute();
   if (OpenDialog1->FileName.Length() < 4) return;

   AnsiString asFileName;
   asFileName = OpenDialog1->FileName;

   lblFileName->Caption = AnsiString("ɦW: ") + asFileName;

   AnsiString asFileExt = ExtractFileExt(asFileName);

   char* pImgExt = NULL;

   bool bSucc = false;
   if (asFileExt.AnsiCompareIC(".jpg") == 0)
   {
      pImgExt = "JPG";

      TJPEGImage *jp = new TJPEGImage();
      jp->LoadFromFile(asFileName);
      Image1->Picture->Bitmap->Assign(jp);
      delete jp;

      bSucc = true;
   }
   else if (asFileExt.AnsiCompareIC(".bmp") == 0)
   {
      pImgExt = "BMP";

      Image1->Picture->Bitmap->LoadFromFile(asFileName);

      bSucc = true;
   }
   else
   {
      ShowMessage("Unknown file format!");
   }

   if (bSucc)
   {
      ImgFit2Rect(Image1, Rect(0, 0, 600, 450));

      lblFileInfo->Caption = AnsiString().sprintf("²z: %s-%s ϧ, e %d,  %d",
         pImgExt,
         g_vPixelFormatStr[Image1->Picture->Bitmap->PixelFormat],
         Image1->Picture->Bitmap->Width,
         Image1->Picture->Bitmap->Height
      );
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
//½
   Graphics::TBitmap *OriBmp = Image1->Picture->Bitmap;
   int nCopyBytes = 3;
   switch (g_vPixelFormatSize[OriBmp->PixelFormat]) {
   case 8:
      nCopyBytes = 1; break;
   case 16:
      nCopyBytes = 2; break;
   case 24:
      nCopyBytes = 3; break;
   case 32:
      nCopyBytes = 4; break;
   default:
      return;
   }
   int nWid, nHei;
   nWid = OriBmp->Width;
   nHei = OriBmp->Height;

   Graphics::TBitmap *NewBmp = new Graphics::TBitmap;
   NewBmp->PixelFormat = OriBmp->PixelFormat;
   NewBmp->Width = nWid;
   NewBmp->Height = nHei;

   byte *pbS, *pbD;
   my4BAry pS, pD;

   for ( int nH = 0; nH < nHei; ++nH)
   {
      pbS = (byte*)OriBmp->ScanLine[nH]+nCopyBytes*(nWid-1);
      pbD = (byte*)NewBmp->ScanLine[nH];

      for( int nW = 0; nW < nWid; ++nW)
      {
         pS = (my4BAry)pbS;
         pD = (my4BAry)pbD;
         for ( register int n = 0; n < nCopyBytes; ++n)
         {
           (*pD)[n]=(*pS)[n];
         }
         pbD += nCopyBytes;
         pbS -= nCopyBytes;
      }
   }

   Image1->Picture->Bitmap->Assign(NewBmp);
   delete NewBmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
//½
   Graphics::TBitmap *OriBmp = Image1->Picture->Bitmap;
   int nCopyBytes = 3;
   switch (g_vPixelFormatSize[OriBmp->PixelFormat]) {
   case 8:
      nCopyBytes = 1; break;
   case 16:
      nCopyBytes = 2; break;
   case 24:
      nCopyBytes = 3; break;
   case 32:
      nCopyBytes = 4; break;
   default:
      return;
   }
   int nWid, nHei;
   nWid = OriBmp->Width;
   nHei = OriBmp->Height;

   Graphics::TBitmap *NewBmp = new Graphics::TBitmap;
   NewBmp->PixelFormat = OriBmp->PixelFormat;
   NewBmp->Width = nWid;
   NewBmp->Height = nHei;

   byte *pbS, *pbD;

   for ( int nH = 0; nH < nHei; ++nH)
   {
      pbS = (byte*)OriBmp->ScanLine[nH];
      pbD = (byte*)NewBmp->ScanLine[(nHei-1)-nH];

      for( int nW = 0; nW < nWid; ++nW)
      {
         for ( register int n = 0; n < nCopyBytes; ++n)
         {
           (pbD)[n]=(pbS)[n];
         }
         pbD += nCopyBytes;
         pbS += nCopyBytes;
      }
   }

   Image1->Picture->Bitmap->Assign(NewBmp);
   delete NewBmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
//V
   Graphics::TBitmap *OriBmp = Image1->Picture->Bitmap;
   int nCopyBytes = 3;
   switch (g_vPixelFormatSize[OriBmp->PixelFormat]) {
   case 8:
      nCopyBytes = 1; break;
   case 16:
      nCopyBytes = 2; break;
   case 24:
      nCopyBytes = 3; break;
   case 32:
      nCopyBytes = 4; break;
   default:
      return;
   }
   int nWid, nHei;
   nWid = OriBmp->Width;
   nHei = OriBmp->Height;

   Graphics::TBitmap *NewBmp = new Graphics::TBitmap;
   NewBmp->PixelFormat = OriBmp->PixelFormat;
   NewBmp->Width = nHei; //!!!
   NewBmp->Height = nWid; //!!!

   byte *pbS, *pbD;

   for ( int nH = 0; nH < nHei; ++nH)
   {
      pbS = (byte*)OriBmp->ScanLine[nH];

      for( int nW = 0; nW < nWid; ++nW)
      {
         pbD = (byte*)NewBmp->ScanLine[(nWid-1)-nW]+nCopyBytes*nH;

         for ( register int n = 0; n < nCopyBytes; ++n)
         {
           (pbD)[n]=(pbS)[n];
         }
         pbS += nCopyBytes;
      }
   }

   int nTmpSz = Image1->Width;
   Image1->Width = Image1->Height;
   Image1->Height = nTmpSz;
   Image1->Picture->Bitmap->Assign(NewBmp);
   ImgFit2Rect(Image1, Rect(0, 0, 600, 450));
   delete NewBmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
//Vk
   Graphics::TBitmap *OriBmp = Image1->Picture->Bitmap;
   int nCopyBytes = 3;
   switch (g_vPixelFormatSize[OriBmp->PixelFormat]) {
   case 8:
      nCopyBytes = 1; break;
   case 16:
      nCopyBytes = 2; break;
   case 24:
      nCopyBytes = 3; break;
   case 32:
      nCopyBytes = 4; break;
   default:
      return;
   }
   int nWid, nHei;
   nWid = OriBmp->Width;
   nHei = OriBmp->Height;

   Graphics::TBitmap *NewBmp = new Graphics::TBitmap;
   NewBmp->PixelFormat = OriBmp->PixelFormat;
   NewBmp->Width = nHei; //!!!
   NewBmp->Height = nWid; //!!!

   byte *pbS, *pbD;

   for ( int nH = 0; nH < nHei; ++nH)
   {
      pbS = (byte*)OriBmp->ScanLine[nH];

      for( int nW = 0; nW < nWid; ++nW)
      {
         pbD = (byte*)NewBmp->ScanLine[nW]+nCopyBytes*((nHei-1)-nH); //!!!

         for ( register int n = 0; n < nCopyBytes; ++n)
         {
           (pbD)[n]=(pbS)[n];
         }
         pbS += nCopyBytes;
      }
   }

   int nTmpSz = Image1->Width;
   Image1->Width = Image1->Height;
   Image1->Height = nTmpSz;
   Image1->Picture->Bitmap->Assign(NewBmp);
   ImgFit2Rect(Image1, Rect(0, 0, 600, 450));
   delete NewBmp;
}
//---------------------------------------------------------------------------
